"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PluginStore = void 0;
class PluginStore {
    constructor() {
        this.plugins = new Set();
    }
    add(plugin) {
        this.plugins.add(plugin);
        return () => {
            this.plugins.delete(plugin);
        };
    }
    exec(type, data, context) {
        let output = data;
        const contextual = Object.freeze(Object.create(context));
        for (const plugin of this.plugins) {
            if (plugin.type === type) {
                output = plugin.action(output, contextual);
            }
        }
        return output;
    }
}
exports.PluginStore = PluginStore;
//# sourceMappingURL=plugin-store.js.map